# SPDX-License-Identifier: GPL-2.0-only OR BSD-2-Clause
%YAML 1.2
---
$id: http://devicetree.org/schemas/display/bridge/parade,ps8622.yaml#
$schema: http://devicetree.org/meta-schemas/core.yaml#

title: Parade PS8622/PS8625 DisplayPort to LVDS Converter

maintainers:
  - Krzysztof Kozlowski <krzk@kernel.org>

properties:
  compatible:
    enum:
      - parade,ps8622
      - parade,ps8625

  reg:
    maxItems: 1

  lane-count:
    $ref: /schemas/types.yaml#/definitions/uint32
    enum: [1, 2]
    description: Number of DP lanes to use.

  use-external-pwm:
    type: boolean
    description: Backlight will be controlled by an external PWM.

  reset-gpios:
    maxItems: 1
    description: GPIO connected to RST_ pin.

  sleep-gpios:
    maxItems: 1
    description: GPIO connected to PD_ pin.

  vdd12-supply: true

  ports:
    $ref: /schemas/graph.yaml#/properties/ports

    properties:
      port@0:
        $ref: /schemas/graph.yaml#/properties/port
        description: Video port for LVDS output.

      port@1:
        $ref: /schemas/graph.yaml#/properties/port
        description: Video port for DisplayPort input.

    required:
      - port@0
      - port@1

required:
  - compatible
  - reg
  - reset-gpios
  - sleep-gpios
  - ports

allOf:
  - if:
      properties:
        compatible:
          const: parade,ps8622
    then:
      properties:
        lane-count:
          const: 1
    else:
      properties:
        lane-count:
          const: 2

additionalProperties: false

examples:
  - |
    #include <dt-bindings/gpio/gpio.h>
    i2c {
        #address-cells = <1>;
        #size-cells = <0>;

        lvds-bridge@48 {
            compatible = "parade,ps8625";
            reg = <0x48>;
            sleep-gpios = <&gpx3 5 GPIO_ACTIVE_HIGH>;
            reset-gpios = <&gpy7 7 GPIO_ACTIVE_HIGH>;
            lane-count = <2>;
            use-external-pwm;

            ports {
                #address-cells = <1>;
                #size-cells = <0>;

                port@0 {
                    reg = <0>;

                    bridge_out: endpoint {
                        remote-endpoint = <&panel_in>;
                    };
                };

                port@1 {
                    reg = <1>;

                    bridge_in: endpoint {
                        remote-endpoint = <&dp_out>;
                    };
                };
            };
        };
    };
